CREATE FUNCTION dbo.fn_ConvertirNumeroALetras (@num INT)
RETURNS NVARCHAR(MAX)
AS
BEGIN
    DECLARE @valor NVARCHAR(MAX)
    DECLARE @cantidad INT
    DECLARE @texto NVARCHAR(MAX)
    DECLARE @unidades NVARCHAR(20) = 'un,dos,tres,cuatro,cinco,seis,siete,ocho,nueve'
    DECLARE @decenas NVARCHAR(100) = 'diez,veinte,treinta,cuarenta,cincuenta,sesenta,setenta,ochenta,noventa'
    DECLARE @diez_nin NVARCHAR(100) = 'once,doce,trece,catorce,quince,dieciseis,diecisiete,dieciocho,diecinueve'
    DECLARE @cientos NVARCHAR(100) = 'cien,doscientos,trescientos,cuatrocientos,quinientos,seiscientos,setecientos,ochocientos,novecientos'
 
    IF @num = 0
        SET @texto = 'cero'
    ELSE
    BEGIN
        SET @valor = CONVERT(NVARCHAR(MAX), @num)
        SET @cantidad = LEN(@valor)
 
        IF @cantidad = 1
            SET @texto = SUBSTRING(@unidades, @num, 1)
        ELSE
        IF @cantidad = 2
        BEGIN
            IF @num <= 19
                SET @texto = SUBSTRING(@diez_nin, @num - 10, 1)
            ELSE
                SET @texto = SUBSTRING(@decenas, @num / 10, 1) + ' y ' + SUBSTRING(@unidades, @num % 10, 1)
        END
        ELSE
        BEGIN
            SET @texto = SUBSTRING(@cientos, @num / 100, 1) + ' '
            IF @num % 100 > 0
                SET @texto = @texto + dbo.fn_ConvertirNumeroALetras(@num % 100)
        END
    END
 
    RETURN @texto
END